import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["getUserListForOrg", "getOrgList", "visible", "dataSourceForUser", "getDataSource"],
    _excluded2 = ["value"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { useEffect, useState, useMemo } from 'react';
import styles from "./index.module.less";
import { Tag, Checkbox, Col, Row, Breadcrumb, Spin, message } from 'antd';
import { get, last, unionBy, uniqBy, keyBy, xorBy } from 'lodash';
import ModalSelector from "../common/modalSelector";
import commonStyles from "../common/index.module.less";
import { formatOptionsList } from "../../utils/index";

var renderUser = function renderUser(userItem) {
  return /*#__PURE__*/React.createElement("div", {
    className: styles['emp-item']
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['avatar']
  }, /*#__PURE__*/React.createElement("img", {
    src: userItem.headIconUrl,
    alt: ""
  })), /*#__PURE__*/React.createElement("div", {
    className: styles['item-info']
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['item-info-name']
  }, userItem.userName, " (", userItem.realName || userItem.userName, ")"), /*#__PURE__*/React.createElement("span", null, userItem.position || '-'), /*#__PURE__*/React.createElement("span", {
    className: styles['row-1']
  }, userItem.orgPathDesc || '-')));
};

var YwEmpSelector = function YwEmpSelector(_ref) {
  var getUserListForOrg = _ref.getUserListForOrg,
      getOrgList = _ref.getOrgList,
      visible = _ref.visible,
      dataSourceForUser = _ref.dataSourceForUser,
      getDataSource = _ref.getDataSource,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var defaultValue = useMemo(function () {
    return formatOptionsList(props.defaultValue || [], {
      label: 'userId',
      value: 'userName'
    }) || [];
  }, [props.defaultValue]);
  useEffect(function () {
    if (!props.value) return;

    var _v = formatOptionsList(props.value || [], {
      label: 'userId',
      value: 'userName'
    }) || [];

    setSelectValue(_v);
    setCheckedList(_v.map(function (v) {
      return v.value;
    }));
  }, [props.value]);

  var _useState = useState(defaultValue.map(function (v) {
    return v.value;
  })),
      checkedList = _useState[0],
      setCheckedList = _useState[1];

  var _useState2 = useState([]),
      checkedDeptList = _useState2[0],
      setCheckedDeptList = _useState2[1];

  var _useState3 = useState(false),
      indeterminate = _useState3[0],
      setIndeterminate = _useState3[1];

  var _useState4 = useState(false),
      checkAll = _useState4[0],
      setCheckAll = _useState4[1];

  var _useState5 = useState([]),
      orgList = _useState5[0],
      setOrgList = _useState5[1];

  var _useState6 = useState(defaultValue),
      selectValue = _useState6[0],
      setSelectValue = _useState6[1]; // const [userList, setUserList] = useState([]);


  var _useState7 = useState(false),
      loading = _useState7[0],
      setLoading = _useState7[1];

  var _useState8 = useState(['[0]']),
      orgPathList = _useState8[0],
      setOrgPathList = _useState8[1];

  var realLength = useMemo(function () {
    return selectValue.reduce(function (prev, curr) {
      var _curr$value, _curr$value2;

      return prev + (curr !== null && curr !== void 0 && (_curr$value = curr.value) !== null && _curr$value !== void 0 && _curr$value.match(/(\d+)人/) ? Number(curr === null || curr === void 0 ? void 0 : (_curr$value2 = curr.value) === null || _curr$value2 === void 0 ? void 0 : _curr$value2.match(/(\d+)人/)[1]) : 1);
    }, 0);
  }, [selectValue]);
  var currentOrg = useMemo(function () {
    return get(orgList, last(orgPathList));
  }, [orgPathList, orgList]);
  var orgPath = useMemo(function () {
    return last(orgPathList);
  }, [orgPathList]); // useEffect(() => {
  //   if (!dataSourceForUser) return;
  //   // setUserList(formatOptionsList(dataSourceForUser, { label: 'userId', value: 'userName' }));
  // }, [dataSourceForUser]);

  var userList = useMemo(function () {
    return formatOptionsList(dataSourceForUser || (currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.userList), {
      label: 'userId',
      value: 'userName'
    });
  }, [currentOrg, dataSourceForUser]);

  var _onChange = function onChange(e, record) {
    if (e.target.checked) {
      var _selectData = unionBy([record], selectValue, 'value');

      if (props.maxItems && (_selectData === null || _selectData === void 0 ? void 0 : _selectData.length) > props.maxItems) {
        message.error('超过数量限制');
        return;
      }

      setCheckedList([].concat(checkedList, [e.target.value]));
      setSelectValue(_selectData);
    } else {
      setCheckedList(checkedList.filter(function (v) {
        return v !== record.value;
      }));
      setSelectValue(xorBy(selectValue, [record], 'value'));
    }
  };

  var onDeptChange = function onDeptChange(e, record) {
    if (e.target.checked) {
      if (realLength + (record.userTotal || 0) > props.maxItems) {
        message.error('超过数量限制');
        return;
      }

      var _selectData = unionBy([record], selectValue, 'value');

      setCheckedDeptList([].concat(checkedDeptList, [e.target.value]));
      setSelectValue(_selectData); // setSelectValue()
    } else {
      setCheckedDeptList(checkedDeptList.filter(function (v) {
        return v !== record.label;
      }));
      setSelectValue(xorBy(selectValue, [record], 'value'));
    }
  };

  useEffect(function () {
    var isAll = !!(userList !== null && userList !== void 0 && userList.length) && (userList === null || userList === void 0 ? void 0 : userList.every(function (item) {
      return checkedList.includes(item.value);
    }));
    setIndeterminate((userList === null || userList === void 0 ? void 0 : userList.some(function (item) {
      return checkedList.includes(item.value);
    })) && !isAll);
    setCheckAll(isAll);
  }, [currentOrg, checkedList]);

  var onCheckAllChange = function onCheckAllChange(e) {
    var _currentOrg$children;

    var deptList = ((currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children) || []).map(function (v) {
      return _extends({}, v, {
        value: v.label + " (" + v.userTotal + "\u4EBA)",
        label: v.value
      });
    });
    var deptValueList = ((_currentOrg$children = currentOrg.children) === null || _currentOrg$children === void 0 ? void 0 : _currentOrg$children.map(function (v) {
      return v.value;
    })) || [];

    if (e.target.checked) {
      var _selectData = unionBy([].concat(userList, deptList), selectValue, 'value');

      if (props.maxItems && (currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.userTotal) > props.maxItems - realLength) {
        message.error('超过数量限制');
        return;
      }

      setSelectValue(_selectData);
      (currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children) && setCheckedDeptList([].concat(checkedDeptList, deptValueList));
    } else {
      setSelectValue(xorBy(selectValue, [].concat(userList, deptList), 'value'));
      setCheckedDeptList(checkedDeptList.filter(function (v) {
        return !deptValueList.includes(v);
      }));
    }

    setCheckedList(e.target.checked ? userList === null || userList === void 0 ? void 0 : userList.map(function (v) {
      return v.value;
    }) : []);
  };

  useEffect(function () {
    setCheckedDeptList([]);
    if (!getOrgList) return;
    setLoading(true);
    getOrgList && getOrgList().then(function (orgList) {
      var res = formatOptionsList([orgList], {
        label: 'orgName',
        value: 'orgId',
        children: 'subOrgList'
      });
      setOrgList(res);
    })["finally"](function () {
      setLoading(false);
    });
  }, []); // const getDeptUser = async (org) => {
  //   setLoading(true);
  //   const res = await getUserListForOrg({ orgIds: [org.value] });
  //   console.log(res);
  //   setUserList(formatOptionsList(res, { label: 'userId', value: 'userName' }));
  //   setLoading(false);
  // };

  var onExpandOrg = function onExpandOrg(org, i) {
    setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
  }; // console.log(get(orgList, `${v}.label`));


  var renderDept = function renderDept() {
    var _currentOrg$children2, _currentOrg$children3;

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: commonStyles['title']
    }, /*#__PURE__*/React.createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), orgPathList && /*#__PURE__*/React.createElement("div", {
      className: commonStyles['dept-list']
    }, /*#__PURE__*/React.createElement(Breadcrumb, null, orgPathList.map(function (v, i) {
      return /*#__PURE__*/React.createElement(Breadcrumb.Item, {
        className: commonStyles['dept-list-path-item'],
        onClick: function onClick() {
          if (i + 1 === orgPathList.length) return;
          setOrgPathList([].concat(orgPathList.slice(0, i + 1))); // getDeptUser(get(orgList, v));
        }
      }, get(orgList, v + ".label"));
    }))), /*#__PURE__*/React.createElement(Row, {
      style: {
        paddingLeft: '20px',
        height: '32px'
      }
    }, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox // disabled={!userList.length}
    , {
      onChange: onCheckAllChange,
      className: styles['check-all'],
      checked: checkAll
    }, "\u5168\u9009"))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children2 = currentOrg.children) !== null && _currentOrg$children2 !== void 0 && _currentOrg$children2.length) && /*#__PURE__*/React.createElement(React.Fragment, null, currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children3 = currentOrg.children) === null || _currentOrg$children3 === void 0 ? void 0 : _currentOrg$children3.map(function (v, i) {
      return /*#__PURE__*/React.createElement(Row, {
        align: "middle",
        className: commonStyles['item-row']
      }, /*#__PURE__*/React.createElement(Col, {
        span: 2,
        style: {
          cursor: 'pointer'
        }
      }, /*#__PURE__*/React.createElement(Checkbox, {
        value: v.value,
        checked: checkedDeptList.includes(v.value),
        onChange: function onChange(e) {
          onDeptChange(e, _extends({}, v, {
            value: v.label + " (" + v.userTotal + "\u4EBA)",
            label: v.value
          }));
        }
      })), /*#__PURE__*/React.createElement(Col, {
        span: 17,
        onClick: function onClick(e) {
          var target = document.querySelectorAll("[value=\"" + v.value + "\"]");

          if (e.target !== target[0]) {
            target && target[0] && target[0].click();
          }
        }
      }, /*#__PURE__*/React.createElement("span", {
        style: {
          paddingLeft: '6px'
        }
      }, v.label, " (", v.userTotal, "\u4EBA)")), /*#__PURE__*/React.createElement(Col, {
        span: 5,
        className: commonStyles['item-row-right'],
        "data-disabled": checkedDeptList.includes(v.value),
        onClick: function onClick() {
          if (checkedDeptList.includes(v.value)) {
            return;
          }

          onExpandOrg(v, i); // getDeptUser(v);
        }
      }, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", {
        src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
      }), /*#__PURE__*/React.createElement("span", {
        style: {
          marginLeft: '6px'
        }
      }, "\u4E0B\u7EA7"))));
    })));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-emp-selector']
  }, /*#__PURE__*/React.createElement(ModalSelector, _extends({}, props, {
    realLength: realLength,
    visible: visible,
    labelInValue: true,
    tagRender: function tagRender(_ref2) {
      var value = _ref2.value,
          props = _objectWithoutPropertiesLoose(_ref2, _excluded2);

      return /*#__PURE__*/React.createElement(Tag, props, value);
    },
    value: selectValue,
    onChange: function onChange(value, data) {
      if (data === void 0) {
        data = [];
      }

      var dataMap = keyBy(data, 'userId');

      var _value = value.map(function (v) {
        var _data$find;

        var userId = (_data$find = data.find(function (item) {
          return item.userName === v.value;
        })) === null || _data$find === void 0 ? void 0 : _data$find.userId;
        return _extends({}, dataMap[userId] || {}, v, {
          label: userId || v.label
        });
      });

      setCheckedList(_value.map(function (v) {
        return v.value;
      }));
      setSelectValue(_value);
      setCheckedDeptList(_value.filter(function (v) {
        var _v$value;

        return !!((_v$value = v.value) !== null && _v$value !== void 0 && _v$value.match(/(\d+)人/));
      }).map(function (v) {
        return v.label;
      }));
    },
    onCancel: function onCancel() {
      props.onCancel && props.onCancel();
      setCheckedList(defaultValue.map(function (v) {
        return v.value;
      }));
      setSelectValue(defaultValue);
      setCheckedDeptList([]);
    },
    onOk: /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(data) {
        var _data$map;

        var res, user, _data;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return getUserListForOrg({
                  orgIds: checkedDeptList === null || checkedDeptList === void 0 ? void 0 : checkedDeptList.join(',')
                });

              case 2:
                res = _context.sent;
                user = data === null || data === void 0 ? void 0 : (_data$map = data.map(function (v) {
                  var _extends2;

                  return _extends({}, v, (_extends2 = {}, _extends2[props.fieldNames.label] = v.userName, _extends2[props.fieldNames.value] = v.label, _extends2));
                })) === null || _data$map === void 0 ? void 0 : _data$map.filter(function (v) {
                  var _v$userName;

                  return !((_v$userName = v.userName) !== null && _v$userName !== void 0 && _v$userName.match(/(\d+)人/));
                });
                _data = uniqBy([].concat((res === null || res === void 0 ? void 0 : res.list) || [], user), 'userId');
                props.onOk(_data);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }(),
    fieldNames: {
      label: 'label',
      value: 'userName'
    },
    fetchOptions: /*#__PURE__*/function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(value) {
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(resolve) {
                    var data, userData;
                    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return getDataSource(value);

                          case 2:
                            _context2.t0 = _context2.sent;

                            if (_context2.t0) {
                              _context2.next = 5;
                              break;
                            }

                            _context2.t0 = [];

                          case 5:
                            data = _context2.t0;
                            userData = data.map(function (user) {
                              return _extends({}, user, {
                                label: renderUser(user),
                                key: user.userId
                              });
                            });
                            resolve(userData);

                          case 8:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function (_x3) {
                    return _ref5.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x2) {
        return _ref4.apply(this, arguments);
      };
    }()
  }), renderDept(), /*#__PURE__*/React.createElement(Spin, {
    spinning: loading
  }, !!(userList !== null && userList !== void 0 && userList.length) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Checkbox.Group, {
    style: {
      width: '100%'
    },
    value: checkedList
  }, userList.map(function (v) {
    return /*#__PURE__*/React.createElement(Row, {
      align: "middle",
      className: styles['emp-item'] + " " + styles['emp-item-row'],
      onClick: function onClick(e) {
        var target = document.querySelectorAll("[value=" + v.value + "]");

        if (e.target !== target[0]) {
          target && target[0] && target[0].click();
        }
      }
    }, /*#__PURE__*/React.createElement(Col, {
      span: 2
    }, /*#__PURE__*/React.createElement(Checkbox, {
      value: v.value,
      onChange: function onChange(e) {
        _onChange(e, v);
      }
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['avatar'],
      span: 4
    }, /*#__PURE__*/React.createElement("img", {
      src: v.headIconUrl
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info']
    }, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info-name']
    }, v.userName)), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['row-1']
    }, v.position))));
  }))))));
};

YwEmpSelector.defaultProps = {
  title: '请选择联系人',
  fieldNames: {
    label: 'userName',
    value: 'userId'
  }
};
export default YwEmpSelector;